#############################################################################
# Makefile for building: GUIDebugger
# Generated by qmake (1.05a) (Qt 3.1.2) on: Thu Dec  2 17:38:16 2004
# Project:  GUIDebugger.pro
# Template: app
# Command: ${QMAKE} -o Makefile GUIDebugger.pro
#############################################################################

##################################################################
include ../../FecHeader.linux
include ../../config/FecRules.linux
##################################################################

#DATABASEFACTORY=DATABASE

ConfigDir:=${XDAQ_ROOT}/config
include ${ConfigDir}/mfAutoconf.rules
#include ${ConfigDir}/mfDefs.linux

#
# Packages to be built
#
BUILD_HOME=${FECSOFTWARE_ROOT}
Project=ThirdParty
Package=GUIDebugger

# Add -I in front of every include directory
PackageGUIIncludeDirs=${XDAQ_ROOT}/include \
			${XDAQ_ROOT}/include/hal \
			${XDAQ_ROOT}/include/hal/linux \
			${XDAQ_ROOT}/${XDAQ_PLATFORM}/include \
			${XDAQ_ROOT}/${XDAQ_PLATFORM}/include/${XDAQ_OS} \
			${FECSOFTWARE_ROOT}/${Package}/include \
			${FECSOFTWARE_ROOT}/generic/include \
			${FECSOFTWARE_ROOT}/FecSupervisor/include \
			${FECUSBSOFT_INCLUDE} \
			${FECSOFT_INCLUDE} \
			${SBSINCLUDEDIR} ${CAENINCLUDEDIR}

# Add -L in front of every library directory
LibraryGUIPaths=${XDAQ_ROOT}/lib \
		${XDAQ_ROOT}/${XDAQ_PLATFORM}/lib \
		${FECSOFTWARE_ROOT}/generic/lib/${XDAQ_OS}/${XDAQ_PLATFORM} \
		${FECUSBSOFTLIBDIR} \
		${DEVICEDRIVERPATH} \
		${SBSLIBDIR} ${CAENLIBDIR}
LibraryGUIList= ${XERCESLIB} ${FECSOFT_LIB}  \
		${HALLIB} ${SBSLIB} ${CAENLIB} DeviceAccess ${FECUSBSOFT_LIB} 

# Check if factory is needed
ifdef DATABASEFACTORY
PackageGUIIncludeDirs += ${ORACLE_INCLUDE}
LibraryGUIPaths += ${ORACLE_LDDFLAGS} ${FED_LIBDIR}
LibraryGUIList += ${ORACLE_LIB} DeviceDescriptions ${FED_LIB} 
endif

IncludeGUIPaths = ${PackageGUIIncludeDirs:%=-I%}
DependentGUILibraryPaths	= ${LibraryGUIPaths:%=-L%}
DependentGUILibraryList		= ${LibraryGUIList:%=-l%}

####### Compiler, tools and options

CC       = gcc
CXX      = g++
LEX      = flex
YACC     = yacc
CFLAGS   = -g -pipe -Wall -std=c++0x -W -I/usr/include/freetype2 -O2  -fno-exceptions -DQT_NO_DEBUG
CXXFLAGS = -g -DBT1003 -w -DQT_THREAD_SUPPORT -DREENTRANT \
	${FECSOFT_C++FLAGS} ${XMLPARSER_C++FLAGS} ${BUSADAPTERC++FLAG} \
	-Wall -std=c++0x -W -I/usr/include/freetype2 -O2  -DQT_NO_DEBUG -DBT1003 -DLINUX
LEXFLAGS = 
YACCFLAGS= -d
INCPATH  = -I${QTDIR}/include -I./. -I./.ui -I.moc/ -I${QTDIR}/mkspecs/default \
	-Iinclude \
	${IncludeGUIPaths}

# Check if factory is needed
ifdef DATABASEFACTORY
CXXFLAGS += ${ORACLE_C++FLAGS} 
endif

LINK     = g++
LFLAGS   = 
LIBS     = ${SUBLIBS} -Wl,-rpath,${QTDIR}/lib -L${QTDIR}/lib -L/usr/X11R6/lib \
	${DependentGUILibraryPaths} ${DependentGUILibraryList} \
	-lqt-mt -lXext -lX11 -lm
#	-lkdeui

AR       = ar cqs
RANLIB   = 
MOC      = ${QTDIR}/bin/moc
UIC      = ${QTDIR}/bin/uic
QMAKE    = qmake
TAR      = tar -cf
GZIP     = gzip -9f
COPY     = cp -f
COPY_FILE= ${COPY} -p
COPY_DIR = ${COPY} -pR
DEL_FILE = rm -f
SYMLINK  = ln -sf
DEL_DIR  = rmdir
MOVE     = mv -f
CHK_DIR_EXISTS= test -d
MKDIR    = mkdir -p

####### Output directory

OBJECTS_DIR = .obj/

####### Files

HEADERS = include/FecDialogImpl.h \
		include/GroupCcuRedundancy.h
SOURCES = src/MainFecDebugger.cc \
		src/FecDialogImpl.cc
OBJECTS = .obj/MainFecDebugger.o \
		.obj/FecDialogImpl.o \
		.obj/FecDialog.o
FORMS = FecDialog.ui
UICDECLS = .ui/FecDialog.h
UICIMPLS = .ui/FecDialog.cpp
SRCMOC   = .moc/moc_GroupCcuRedundancy.cpp \
		.moc/moc_FecDialog.cpp
OBJMOC = .obj/moc_GroupCcuRedundancy.o \
		.obj/moc_FecDialog.o
DIST	   = GUIDebugger.pro
QMAKE_TARGET = GUIDebugger
DESTDIR  = 
TARGET   = GUIDebugger

first: all
####### Implicit rules

.SUFFIXES: .c .cpp .cc .cxx .C

.cpp.o:
	${CXX} -c ${CXXFLAGS} ${INCPATH} -o $@ $<

.cc.o:
	${CXX} -c ${CXXFLAGS} ${INCPATH} -o $@ $<

.cxx.o:
	${CXX} -c ${CXXFLAGS} ${INCPATH} -o $@ $<

.C.o:
	${CXX} -c ${CXXFLAGS} ${INCPATH} -o $@ $<

.c.o:
	${CC} -c ${CFLAGS} ${INCPATH} -o $@ $<

####### Build rules

all: Makefile ${TARGET}

${TARGET}:  ${UICDECLS} ${OBJECTS} ${OBJMOC} 
	${LINK} ${LFLAGS} -o ${TARGET} ${OBJECTS} ${OBJMOC} ${LIBS}

mocables: ${SRCMOC}

${MOC}: 
	( cd ${QTDIR}/src/moc ; ${MAKE} )

Makefile: GUIDebugger.pro  ${QTDIR}/mkspecs/default/qmake.conf 
	${QMAKE} -o Makefile GUIDebugger.pro
qmake: 
	@${QMAKE} -o Makefile GUIDebugger.pro

dist: 
	@mkdir -p .obj/GUIDebugger && ${COPY_FILE} --parents ${SOURCES} ${HEADERS} ${FORMS} ${DIST} .obj/GUIDebugger/ && ${COPY_FILE} --parents FecDialog.ui.h .obj/GUIDebugger/ && ( cd `dirname .obj/GUIDebugger` && ${TAR} GUIDebugger.tar GUIDebugger && ${GZIP} GUIDebugger.tar } && ${MOVE} `dirname .obj/GUIDebugger`/GUIDebugger.tar.gz . && ${DEL_FILE} -r .obj/GUIDebugger

mocclean:
	-${DEL_FILE} ${OBJMOC}
	-${DEL_FILE} ${SRCMOC}

uiclean:
	-${DEL_FILE} ${UICIMPLS} ${UICDECLS}

yaccclean:
lexclean:
clean: mocclean uiclean
	-${DEL_FILE} ${OBJECTS} 
	-${DEL_FILE} *~ core *.core


####### Sub-libraries

distclean: clean
	-${DEL_FILE} ${TARGET} ${TARGET}


FORCE:

####### Compile

.obj/MainFecDebugger.o: src/MainFecDebugger.cc include/FecDialogImpl.h \
		.ui/FecDialog.h \
		include/GroupCcuRedundancy.h
	${CXX} -c ${CXXFLAGS} ${INCPATH} -o .obj/MainFecDebugger.o src/MainFecDebugger.cc

.obj/FecDialogImpl.o: src/FecDialogImpl.cc include/FecDialogImpl.h \
		.ui/FecDialog.h \
		include/GroupCcuRedundancy.h
	${CXX} -c ${CXXFLAGS} ${INCPATH} -o .obj/FecDialogImpl.o src/FecDialogImpl.cc

.ui/FecDialog.h: FecDialog.ui 
	${UIC} FecDialog.ui -o .ui/FecDialog.h

.ui/FecDialog.cpp: .ui/FecDialog.h FecDialog.ui 
	${UIC} FecDialog.ui -i .ui/FecDialog.h -o .ui/FecDialog.cpp

.obj/FecDialog.o: .ui/FecDialog.cpp FecDialog.ui \
		.ui/FecDialog.h
	${CXX} -c ${CXXFLAGS} ${INCPATH} -o .obj/FecDialog.o .ui/FecDialog.cpp

.obj/moc_GroupCcuRedundancy.o: .moc/moc_GroupCcuRedundancy.cpp include/GroupCcuRedundancy.h 
	${CXX} -c ${CXXFLAGS} ${INCPATH} -o .obj/moc_GroupCcuRedundancy.o .moc/moc_GroupCcuRedundancy.cpp

.obj/moc_FecDialog.o: .moc/moc_FecDialog.cpp .ui/FecDialog.h 
	${CXX} -c ${CXXFLAGS} ${INCPATH} -o .obj/moc_FecDialog.o .moc/moc_FecDialog.cpp

.moc/moc_GroupCcuRedundancy.cpp: ${MOC} include/GroupCcuRedundancy.h
	${MOC} include/GroupCcuRedundancy.h -o .moc/moc_GroupCcuRedundancy.cpp

.moc/moc_FecDialog.cpp: ${MOC} .ui/FecDialog.h
	${MOC} .ui/FecDialog.h -o .moc/moc_FecDialog.cpp

####### Install

install: all 

uninstall: 

